#include "graphics.h"

GdkPixmap *Pixmap;
GdkWindow *Fenetre;
GdkGC *gc;
GdkColor foreground_color;
GdkColor background_color;
pthread_t th_boucle_even;	

unsigned larg,haut;

void maboucle_even()
   {

   GdkEvent *ev;

   while (1) 
      {

      if (gdk_events_pending()) 
         {
         while ((ev = gdk_event_get())!=NULL) 
            {
				if ( ev->type == GDK_DELETE)
					{
					printf("GDK_DELETE dtect\n");
					gdk_window_destroy(Fenetre);
					pthread_exit(NULL);
					}
            gdk_event_free(ev);
            }
         gdk_draw_pixmap(Fenetre, gc, Pixmap, 0, 0, 0, 0, -1, -1);
         }
      }
   }

void creer_fenetre(unsigned int width, unsigned int height, char *bg_color, char *fg_color)
   {

   GdkWindowAttr attr;
   GdkColormap *colormap;

   
	
   /* initialisation de la bibliotheque */
   gdk_init(NULL, NULL);
   
   colormap = gdk_colormap_get_system();
   
   larg=width;
   haut=height;
   /* creation de la fenetre */
   attr.title = "fenetre 1";
   attr.event_mask = 0;
   attr.width = width;
   attr.height = height;
   attr.wclass = GDK_INPUT_OUTPUT;
   attr.window_type = GDK_WINDOW_TOPLEVEL;
   Fenetre = gdk_window_new(NULL, &attr, GDK_WA_TITLE);
   
   
   gdk_color_parse(bg_color, &background_color);
   gdk_color_parse(fg_color, &foreground_color);
   gdk_colormap_alloc_color(colormap, &background_color, FALSE, TRUE); 
   gdk_colormap_alloc_color(colormap, &foreground_color, FALSE, TRUE); 

   Pixmap = gdk_pixmap_new(Fenetre, attr.width ,attr.height , -1);


   gc = gdk_gc_new(Fenetre);


   gdk_gc_set_foreground(gc, &background_color);
   gdk_draw_rectangle(Pixmap, gc, TRUE,
                             0,
                             0,
                             larg,
                             haut);
   gdk_draw_pixmap(Fenetre, gc, Pixmap, 0, 0, 0, 0, -1, -1);
   gdk_gc_set_foreground(gc, &foreground_color);

   gdk_window_show(Fenetre);
			             
   pthread_create(&th_boucle_even, NULL, (void * (*)(void *))maboucle_even, NULL);
   }

void effacer_fenetre()
   {
   gdk_gc_set_foreground(gc, &background_color);
   gdk_draw_rectangle(Pixmap, gc, TRUE,
                             0,
                             0,
                             larg,
                             haut);
   gdk_draw_pixmap(Fenetre, gc, Pixmap, 0, 0, 0, 0, -1, -1);
   gdk_gc_set_foreground(gc, &foreground_color);
   }

void attendre_fermeture_fenetre()
	{
	pthread_join(th_boucle_even,NULL);
	}

void afficher_point(unsigned int x, unsigned int y)
   {
   if ((x >= larg) || (y >= haut))
      {
      printf("Erreur coordonnees non valides\n");
      }
   else
      {
      gdk_draw_point(Pixmap, gc, x, y);
      gdk_draw_pixmap(Fenetre, gc, Pixmap, 0, 0, 0, 0, -1, -1);
      }
   }

void afficher_point_rapide(unsigned int x, unsigned int y)
   {
   if ((x >= larg) || (y >= haut))
      {
      printf("Erreur coordonnees non valides\n");
      }
   else
      {
      gdk_draw_point(Pixmap, gc, x, y);
      gdk_draw_point(Fenetre, gc, x, y);
      }
   }

void effacer_point(unsigned int x, unsigned int y)
   {
   if ((x >= larg) || (y >= haut))
      {
      printf("Erreur coordonnees non valides\n");
      }
   else
      {
      gdk_gc_set_foreground(gc, &background_color);
      gdk_draw_point(Pixmap, gc, x, y);
      gdk_draw_point(Fenetre, gc, x, y);
      gdk_gc_set_foreground(gc, &foreground_color);
      }
   }

void afficher_ligne(unsigned x1,unsigned y1,unsigned x2,unsigned y2)
   {
   int deltax,deltay;
   int x,y;
   int signedeltax,signedeltay;
   int aux;
   int permutxy;
   int eu;
   int i;
  
 /*version bresenham*/

   x=x1;
   y=y1;

   deltax = abs(x2-x1);
   deltay = abs(y2-y1);

   signedeltax=(x2>x1)?1:-1;
   signedeltay=(y2>y1)?1:-1;

   permutxy=0;
   if (deltay > deltax)
      {
      aux=deltax;deltax=deltay;deltay=aux;
      permutxy=1;
      }
   eu=(2*deltay) - deltax;
   for (i=1;i<=deltax;i++)
      {
      afficher_point(x,y);
      while (eu >= 0)
         {
         if (permutxy == 1)
            {
            x += signedeltax;
            }
         else
            {
            y += signedeltay;
            }
         eu -= 2*deltax;
         }
      if (permutxy == 1)
         {
         y += signedeltay;
         }
      else
         {
         x += signedeltax;
         }
      eu += 2*deltay;
      }
   }

void afficher_ligne_rapide(unsigned x1,unsigned y1,unsigned x2,unsigned y2)
   {
   int deltax,deltay;
   int x,y;
   int signedeltax,signedeltay;
   int aux;
   int permutxy;
   int eu;
   int i;
  
 /*version bresenham*/

   x=x1;
   y=y1;

   deltax = abs(x2-x1);
   deltay = abs(y2-y1);

   signedeltax=(x2>x1)?1:-1;
   signedeltay=(y2>y1)?1:-1;

   permutxy=0;
   if (deltay > deltax)
      {
      aux=deltax;deltax=deltay;deltay=aux;
      permutxy=1;
      }
   eu=(2*deltay) - deltax;
   for (i=1;i<=deltax;i++)
      {
      afficher_point_rapide(x,y);
      while (eu >= 0)
         {
         if (permutxy == 1)
            {
            x += signedeltax;
            }
         else
            {
            y += signedeltay;
            }
         eu -= 2*deltax;
         }
      if (permutxy == 1)
         {
         y += signedeltay;
         }
      else
         {
         x += signedeltax;
         }
      eu += 2*deltay;
      }
   }
